## widelands 1.2.1

=== doc/CMakeLists.txt ===
IF (NOT WIN32)
  find_package(Doxygen)
  if (DOXYGEN_FOUND)
    include(${CMAKE_SOURCE_DIR}/cmake/Modules/Documentation.cmake)
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/sourcecode)
    configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY IMMEDIATE)
    add_custom_target(doc COMMAND ${DOXYGEN_EXECUTABLE} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_CURRENT_BINARY_DIR}/sourcecode)
  else (DOXYGEN_FOUND)
    add_custom_target(doc COMMAND ${CMAKE_COMMAND} -E echo "Doxygen not found, make doc is disabled")
    message ("Doxygen not found, disabling 'make doc'")
  endif (DOXYGEN_FOUND)
ENDIF (NOT WIN32)

=== po/CMakeLists.txt ===
add_custom_target (
    lang ALL
)

macro(CreateLocale locale_name)
  set (commands "")
  file (GLOB_RECURSE pofiles *.po)
  foreach (pofile ${pofiles})
    get_filename_component(pofile_name ${pofile} NAME_WE)
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" pofile_subpath ${pofile})
    get_filename_component(pofile_path ${pofile} PATH)
    string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" template_name ${pofile_path})
    if (${pofile_name} STREQUAL ${locale_name})
      add_custom_command (
	OUTPUT ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo
	COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES
	COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE} -q --no-wrap ${pofile} ${CMAKE_CURRENT_SOURCE_DIR}/${template_name}/${template_name}.pot -o ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
	COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} -o ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
	COMMAND cmake -E remove ${CMAKE_CURRENT_BINARY_DIR}/${locale_name}_${template_name}.tmp.po
        DEPENDS ${pofile}
        COMMENT "Generating translations for locale ${locale_name} category ${template_name}"
      )
      list(APPEND commands ${CMAKE_BINARY_DIR}/locale/${locale_name}/LC_MESSAGES/${template_name}.mo)
    endif (${pofile_name} STREQUAL ${locale_name})
  endforeach (pofile ${pofiles})
  add_custom_target (
    translang_${locale_name}
    DEPENDS ${commands}
  )
  add_custom_target (
    lang_${locale_name}
    COMMAND cmake -Dlang=${locale_name} -Dpobasedir=${CMAKE_CURRENT_SOURCE_DIR} -Dlocalebasedir=${CMAKE_BINARY_DIR}/locale -P ${CMAKE_CURRENT_SOURCE_DIR}/CheckLocale.cmake
    COMMENT "Checking translations for locale ${locale_name}"
  )
  add_dependencies(lang lang_${locale_name})
  add_dependencies(lang_${locale_name} translang_${locale_name})
endmacro(CreateLocale locale_name)

set (languages_found "")
file (GLOB_RECURSE pofiles *.po)
foreach(pofile ${pofiles})
  get_filename_component(pofile ${pofile} NAME_WE)
  list(APPEND languages_found ${pofile})
endforeach(pofile ${pofiles})

list(SORT languages_found)
list(REMOVE_DUPLICATES languages_found)

foreach(language ${languages_found})
  CreateLocale(${language})
endforeach(language ${languages_found})

=== src/CMakeLists.txt ===
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/build_info.cc.cmake ${CMAKE_CURRENT_BINARY_DIR}/build_info.cc)
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../cmake/datadirversion.cmake ${CMAKE_CURRENT_SOURCE_DIR}/../data/datadirversion)

# Catchall target to codecheck all files.
add_custom_target(codecheck)
add_custom_target(run_build_deps
  COMMAND
    ${Python3_EXECUTABLE}
    ${CMAKE_SOURCE_DIR}/utils/build_deps.py
  COMMENT "Checking CMakeLists.txt files."
)
add_dependencies(codecheck run_build_deps)

# A target that depends on all unit tests as 'make test' will not rebuild
# tests:
# https://stackoverflow.com/questions/733475/cmake-ctest-make-test-doesnt-build-tests
add_custom_target(wl_tests)

#include the cmake version dependend macro _include_directories
if (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectoriesOld.cmake)
else (CMAKE_VERSION VERSION_LESS 2.8.11)
  include (${CMAKE_SOURCE_DIR}/cmake/IncludeDirectories.cmake)
endif (CMAKE_VERSION VERSION_LESS 2.8.11)

wl_library(build_info
  SRCS
    build_info.cc
    build_info.h
)

if (WIN32)
	configure_file (${CMAKE_CURRENT_SOURCE_DIR}/../utils/windows/widelands.rc.cmake ${CMAKE_CURRENT_BINARY_DIR}/widelands.rc)
	message (STATUS "Configured windows resource file")
	set(WIN32_ICON_O ${CMAKE_CURRENT_BINARY_DIR}/wl_icon.o)
	if(MSVC)
		ADD_CUSTOM_COMMAND(OUTPUT ${WIN32_ICON_O}
			COMMAND rc
				/fo ${WIN32_ICON_O}
				${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
		)
	else()
		ADD_CUSTOM_COMMAND(OUTPUT ${WIN32_ICON_O}
			COMMAND ${MINGW_PREFIX}windres
				-o${WIN32_ICON_O}
				-i${CMAKE_CURRENT_BINARY_DIR}/widelands.rc
		)
	endif()

  wl_binary(widelands
    WIN32
    SRCS
      main.cc
      ${WIN32_ICON_O}
    DEPENDS
      base_exceptions
      widelands_ball_of_mud
      build_info
  )
else()
  wl_binary(widelands
    SRCS
      main.cc
    DEPENDS
      base
      base_exceptions
      base_time_string
      logic_filesystem_constants
      widelands_ball_of_mud
      build_info
  )
endif()

if(OPTION_FORCE_EMBEDDED_MINIZIP)
    # unset these two if they are cached
    unset(MINIZIP_FOUND)
    set(MINIZIP_STATIC_LIBRARIES "")
else()
   # If pkg-config is ever needed to find other libraries, move the include outside the if() block
  include(FindPkgConfig)
  if(PKG_CONFIG_FOUND)
    pkg_check_modules(MINIZIP minizip)
  endif()
endif()

add_subdirectory(third_party)
add_subdirectory(ai)
add_subdirectory(base)
add_subdirectory(chat)
add_subdirectory(economy)
add_subdirectory(editor)
add_subdirectory(game_io)
add_subdirectory(graphic)
add_subdirectory(io)
add_subdirectory(logic)
add_subdirectory(map_io)
add_subdirectory(network)
add_subdirectory(notifications)
add_subdirectory(scripting)
add_subdirectory(sound)
add_subdirectory(ui_basic)
add_subdirectory(ui_fsmenu)
if (OPTION_BUILD_WEBSITE_TOOLS)
  add_subdirectory(website)
endif (OPTION_BUILD_WEBSITE_TOOLS)
add_subdirectory(wui)

# TODO(unknown): Ideally widelands_ball_of_mud shouldn't exist, everything should be in a
# library.
wl_library(widelands_ball_of_mud
  SRCS
    wlapplication.cc
    wlapplication.h
    wlapplication_messages.cc
    wlapplication_messages.h
  USES_ATOMIC
  USES_SDL2
  USES_SDL2_TTF
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    base_random
    base_time_string
    build_info
    editor
    graphic
    graphic_fonthandler
    graphic_mouse_cursor
    graphic_text
    io_filesystem
    logic
    logic_addons
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_map
    logic_single_player_game_settings
    map_io_map_loader
    network
    sound
    ui_basic
    ui_fsmenu
    widelands_options
    wui
    wui_chat_ui
    wui_common_mapdetails
)

wl_library(widelands_options
  SRCS
    wlapplication_options.cc
    wlapplication_options.h
    wlapplication_mousewheel_options.cc
    wlapplication_mousewheel_options.h
  DEPENDS
    base
    base_geometry
    graphic_text_layout
    io_filesystem
    io_profile
    logic_filesystem_constants
  USES_SDL2
)

if (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "NetBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  target_link_libraries(widelands_ball_of_mud ${EXECINFO_LIBRARY})
endif (CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR
       CMAKE_SYSTEM_NAME MATCHES "NetBSD" OR
       CMAKE_SYSTEM_NAME MATCHES "OpenBSD")

if (WIN32)
  target_link_libraries(widelands_ball_of_mud wsock32)
#  set_target_properties(widelands PROPERTIES LINK_FLAGS_RELEASE -s)
endif (WIN32)

=== doc/sphinx/requirements.txt ===
sphinxcontrib-serializinghtml<1.1.6
sphinx<7.2

=== src/ai/CMakeLists.txt ===
add_subdirectory(test)

wl_library(ai_hints
  SRCS
    ai_hints.cc
    ai_hints.h
  DEPENDS
    base
    base_macros
    logic_constants
    logic_exceptions
    scripting_lua_table
)

wl_library(ai
  SRCS
    ai_help_structs.cc
    ai_help_structs.h
    computer_player.cc
    computer_player.h
    defaultai_seafaring.cc
    defaultai_warfare.cc
    defaultai.cc
    defaultai.h
  DEPENDS
    ai_hints
    base
    base_exceptions
    base_macros
    base_time_string
    economy
    logic
    logic_constants
    logic_commands
    logic_game_controller
    logic_map
    logic_map_objects
)

=== src/base/CMakeLists.txt ===
add_subdirectory(test)

wl_library(base
  SRCS
    format/abstract_node.h
    format/boolean_node.h
    format/common_nodes.h
    format/float_node.h
    format/number_node.h
    format/string_node.h
    format/tree.cc
    format/tree.h
    format/wildcard_node.h
    format/write_number.h
    i18n.h
    i18n.cc
    multithreading.h
    multithreading.cc
    mutex.h
    log.cc
    log.h
    string.h
    string.cc
  USES_ATOMIC
  USES_INTL
  USES_SDL2
  DEPENDS
    base_exceptions
    base_macros
    base_times
    build_info
    io_filesystem
    logic_filesystem_constants
    notifications
    third_party_gettext
)

wl_library(base_macros
  SRCS
    macros.h
    macros.cc
)

wl_library(base_exceptions
  SRCS
    exceptions.cc
    warning.h
    wexception.h
  DEPENDS
    base_macros
)

wl_library(base_utf8
  SRCS
    utf8.h
    utf8.cc
)

wl_library(base_geometry
  SRCS
    rect.h
    vector.h
    vector.cc
)

wl_library(base_crypto
  SRCS
    crypto.cc
    crypto.h
  DEPENDS
    third_party_libmd
)

wl_library(base_random
  SRCS
    random.h
    random.cc
  DEPENDS
    io_stream
    base_exceptions
)


wl_library(base_scoped_timer
  SRCS
    scoped_timer.h
    scoped_timer.cc
  USES_SDL2
  DEPENDS
    base
    base_macros
)


wl_library(base_time_string
  SRCS
    time_string.h
    time_string.cc
  DEPENDS
    base
)


wl_library(base_times
  SRCS
    times.h
    times.cc
  USES_ATOMIC
  DEPENDS
    base_exceptions
    io_fileread
)


wl_library(base_math
  SRCS
    math.h
    math.cc
  DEPENDS
    base_exceptions
)

wl_library(base_test
  SRCS
    test.h
    test.cc
  DEPENDS
    base
    base_exceptions
)

=== src/economy/CMakeLists.txt ===
wl_library(economy
  SRCS
    cmd_call_economy_balance.cc
    cmd_call_economy_balance.h
    economy.cc
    economy.h
    economy_data_packet.cc
    economy_data_packet.h
    expedition_bootstrap.cc
    expedition_bootstrap.h
    ferry_fleet.cc
    ferry_fleet.h
    flag.cc
    flag.h
    flag_job.h
    idleworkersupply.cc
    idleworkersupply.h
    iroute.h
    itransport_cost_calculator.h
    portdock.cc
    portdock.h
    request.cc
    request.h
    roadbase.cc
    roadbase.h
    road.cc
    road.h
    route.cc
    route.h
    routeastar.cc
    routeastar.h
    router.cc
    router.h
    routing_node.h
    ship_fleet.cc
    ship_fleet.h
    shippingitem.cc
    shippingitem.h
    shipping_schedule.cc
    shipping_schedule.h
    soldier_request.cc
    soldier_request.h
    supply.h
    supply_list.cc
    supply_list.h
    trackptr.h
    transfer.cc
    transfer.h
    ware_instance.cc
    ware_instance.h
    warehousesupply.h
    input_queue.cc
    input_queue.h
    ware_priority.cc
    ware_priority.h
    wares_queue.cc
    wares_queue.h
    waterway.cc
    waterway.h
    workers_queue.cc
    workers_queue.h
  DEPENDS
    base
    base_exceptions
    base_macros
    base_times
    graphic
    io_fileread
    io_stream
    logic
    logic_commands
    logic_constants
    logic_exceptions
    logic_map
    logic_map_objects
    logic_widelands_geometry
    logic_widelands_geometry_io
    map_io
    notifications
)
add_subdirectory(test)

=== src/graphic/CMakeLists.txt ===
add_subdirectory(animation)
add_subdirectory(styles)
add_subdirectory(text)

# TODO(sirver): Separate this directory into a base directory and one
# that is Widelands aware (can include logic stuff).

# Align and color

wl_library(graphic_toolbar_imageset
  SRCS
    toolbar_imageset.cc
    toolbar_imageset.h
  DEPENDS
    graphic
    graphic_surface
    scripting_lua_table
)

wl_library(graphic_align
  SRCS
    align.h
    align.cc
  DEPENDS
    base_geometry
)

wl_library(graphic_color
  SRCS
    color.h
    color.cc
  DEPENDS
    base
  USES_SDL2
)

wl_library(graphic_playercolor
  SRCS
    playercolor.cc
    playercolor.h
  DEPENDS
    base
    graphic
    graphic_color
    graphic_surface
    io_filesystem
)


# Rendering utils

wl_library(graphic_build_texture_atlas
  SRCS
    build_texture_atlas.h
    build_texture_atlas.cc
  DEPENDS
    base
    graphic
    graphic_image_io
    graphic_surface
    graphic_texture_atlas
    io_filesystem
    io_profile
    logic_filesystem_constants
)

wl_library(graphic_image_io
  SRCS
    image_io.h
    image_io.cc
  USES_PNG
  USES_SDL2_IMAGE
  DEPENDS
    base_exceptions
    graphic_surface
    io_fileread
    io_filesystem
    io_stream
)

wl_library(graphic_sdl_utils
  SRCS
    sdl_utils.h
    sdl_utils.cc
  USES_SDL2
)

wl_library(graphic_gl_utils
  SRCS
    gl/blit_data.h
    gl/coordinate_conversion.h
    gl/initialize.cc
    gl/initialize.h
    gl/system_headers.h
    gl/utils.cc
    gl/utils.h
  USES_SDL2
  USES_OPENGL
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    graphic_text
    io_fileread
    io_filesystem
)

wl_library(graphic_surface
  SRCS
    image.h
    screen.cc
    screen.h
    surface.cc
    surface.h
    texture.cc
    texture.h
  USES_SDL2
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    graphic_color
    graphic_draw_programs
    graphic_gl_utils
    graphic_render_queue
    graphic_sdl_utils
)

wl_library(graphic_texture_atlas
  SRCS
    texture_atlas.h
    texture_atlas.cc
  DEPENDS
    base_exceptions
    base_macros
    graphic_surface
)

wl_library(graphic_draw_programs
  SRCS
    blend_mode.h
    blit_mode.h
    gl/blit_program.cc
    gl/blit_program.h
    gl/draw_line_program.cc
    gl/draw_line_program.h
    gl/fill_rect_program.cc
    gl/fill_rect_program.h
  DEPENDS
    base_exceptions
    base_macros
    base_geometry
    graphic_gl_utils
    graphic_color
)


# Logic-aware stuff

wl_library(graphic_render_queue
  SRCS
    render_queue.cc
    render_queue.h
  DEPENDS
    base_exceptions
    base_geometry
    base_macros
    graphic_color
    graphic_draw_programs
    graphic_fields_to_draw
    graphic_terrain_programs
    logic_map_objects
    logic_map_objects_description_maintainer
)

wl_library(graphic_game_renderer
  SRCS
    game_renderer.cc
    game_renderer.h
  DEPENDS
    graphic
    graphic_fields_to_draw
    graphic_render_queue
    graphic_surface
    logic
    logic_map_objects
)

wl_library(graphic_minimap_renderer
  SRCS
    minimap_renderer.cc
    minimap_renderer.h
  USES_SDL2
  DEPENDS
    base_geometry
    economy
    graphic_playercolor
    graphic_surface
    logic
    logic_constants
    logic_map
    logic_map_objects
    wui_mapview_pixelfunctions
)

wl_library(graphic_fields_to_draw
  SRCS
    gl/fields_to_draw.cc
    gl/fields_to_draw.h
  DEPENDS
    base
    base_geometry
    graphic
    graphic_gl_utils
    logic
    logic_constants
    logic_map_objects
    logic_widelands_geometry
    wui_mapview_pixelfunctions
)

wl_library(graphic_terrain_programs
  SRCS
    gl/grid_program.cc
    gl/grid_program.h
    gl/road_program.cc
    gl/road_program.h
    gl/terrain_program.cc
    gl/terrain_program.h
    gl/dither_program.cc
    gl/dither_program.h
    gl/workarea_program.cc
    gl/workarea_program.h
  USES_ATOMIC
  DEPENDS
    base_exceptions
    base_geometry
    base_macros
    graphic
    graphic_fields_to_draw
    graphic_gl_utils
    graphic_image_io
    graphic_surface
    io_filesystem
    logic
    logic_map_objects
    logic_map_objects_description_maintainer
    wui_mapview_pixelconstants
)


# Font handler and text
wl_library(graphic_fonthandler
  SRCS
    font_handler.cc
    font_handler.h
  DEPENDS
    base
    base_macros
    graphic
    graphic_text
)

wl_library(graphic_text_layout
  SRCS
    text_layout.cc
    text_layout.h
  DEPENDS
    base
    graphic # TODO(Gunchleoc): For text_width safety only - rewrite that function
    graphic_align
    graphic_color
    graphic_surface
    graphic_styles
    graphic_text
    graphic_fonthandler
)

wl_library(graphic_wordwrap
  SRCS
    wordwrap.cc
    wordwrap.h
  USES_ICU
  DEPENDS
    base
    base_geometry
    graphic
    graphic_align
    graphic_color
    graphic_fonthandler
    graphic_text
    graphic_text_layout
)


# Mouse cursor

wl_library(graphic_mouse_cursor
  SRCS
    mouse_cursor.cc
    mouse_cursor.h
  USES_SDL2
  DEPENDS
    base_geometry
    graphic
    graphic_image_io
    io_filesystem
)


# Misc high-level helper and convenience functions

wl_library(graphic_functions
  SRCS
    graphic_functions.cc
    graphic_functions.h
  DEPENDS
    graphic
    graphic_fonthandler
    graphic_text_layout
)

# Base library

wl_library(graphic
  SRCS
    default_resolution.h
    graphic.cc
    graphic.h
    note_graphic_resolution_changed.h
    hyperlink.h
    image_cache.cc
    image_cache.h
    style_manager.cc
    style_manager.h
    rendertarget.cc
    rendertarget.h
    road_segments.cc
    road_segments.h
  USES_SDL2
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    base_scoped_timer
    base_times
    build_info
    graphic_align
    graphic_animation
    graphic_build_texture_atlas
    graphic_color
    graphic_draw_programs
    graphic_gl_utils
    graphic_image_io
    graphic_render_queue
    graphic_styles
    graphic_surface
    io_filesystem
    io_stream
    logic_widelands_geometry
    notifications
    scripting_lua_interface
    scripting_lua_table
)

=== src/io/CMakeLists.txt ===
add_subdirectory(filesystem)

wl_library(io_stream
  SRCS
    machdep.h
    streamread.cc
    streamread.h
    streamwrite.cc
    streamwrite.h
  USES_SDL2
  DEPENDS
    base_exceptions
    base_macros
)

wl_library(io_fileread
  SRCS
    fileread.cc
    fileread.h
    filewrite.cc
    filewrite.h
  DEPENDS
    io_filesystem
    io_stream
)

wl_library(io_profile
  SRCS
    profile.h
    profile.cc
  USES_ATOMIC
  DEPENDS
    base
    base_exceptions
    base_geometry
    base_macros
    build_info
    io_fileread
    io_filesystem
 )

=== src/logic/CMakeLists.txt ===
wl_library(logic_exceptions
  SRCS
    game_data_error.cc
    game_data_error.h
  DEPENDS
    base
    base_exceptions
)

wl_library(logic_widelands_geometry
  SRCS
    widelands_geometry.cc
    widelands_geometry.h
)

wl_library(logic_widelands_geometry_io
  SRCS
    widelands_geometry_io.cc
    widelands_geometry_io.h
  DEPENDS
    io_fileread
    io_stream
    logic_constants
    logic_widelands_geometry
)

wl_library(logic_game_settings
  SRCS
    game_settings.cc
    game_settings.h
    player_end_result.h
  DEPENDS
    graphic_color
    io_filesystem
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_tribe_basic_info
    notifications
    scripting_lua_interface
    scripting_lua_table
)

wl_library(logic_single_player_game_settings
  SRCS
    single_player_game_settings_provider.cc
    single_player_game_settings_provider.h
  DEPENDS
    ai
    base
    base_exceptions
    base_random
    graphic_playercolor
    logic_game_settings
    logic_tribe_basic_info
)

wl_library(logic_game_controller
  SRCS
    game_controller.h
    replay_game_controller.h
    replay_game_controller.cc
    single_player_game_controller.h
    single_player_game_controller.cc
  USES_SDL2
  DEPENDS
    ai
    base_times
    logic
    logic_commands
    logic_game_settings
    ui_basic
    widelands_options
    wui
)

wl_library(logic_constants
  SRCS
    vision.h
    widelands.cc
    widelands.h
  DEPENDS
    base_exceptions
)

wl_library(logic_filesystem_constants
  SRCS
    filesystem_constants.h
    filesystem_constants.cc
)

wl_library(logic_addons
  SRCS
    addons.cc
    addons.h
    mutable_addon.cc
    mutable_addon.h
  DEPENDS
    base
    base_exceptions
    base_math
    base_time_string
    build_info
    graphic
    graphic_text_layout
    io_fileread
    io_filesystem
    io_profile
    logic_filesystem_constants
    logic_map
    map_io
    map_io_map_loader
    widelands_options
)

wl_library(logic_objectives
  SRCS
    objective.cc
    objective.h
  DEPENDS
    base
)


wl_library(logic_generic_save_handler
  SRCS
    generic_save_handler.h
    generic_save_handler.cc
  DEPENDS
    base
    base_time_string
    io_filesystem
    logic_filesystem_constants
)

wl_library(logic_map
  SRCS
    cookie_priority_queue.h
    field.cc
    field.h
    map.cc
    map.h
    map_compassdir.cc
    map_compassdir.h
    map_revision.cc
    map_revision.h
    mapastar.cc
    mapastar.h
    mapdifferenceregion.cc
    mapdifferenceregion.h
    mapfringeregion.cc
    mapfringeregion.h
    maphollowregion.cc
    maphollowregion.h
    mapregion.h
    maptriangleregion.cc
    maptriangleregion.h
    nodecaps.h
    note_map_options.h
    path.cc
    path.h
    pathfield.cc
    pathfield.h
  USES_ATOMIC
  DEPENDS
    base
    base_exceptions
    base_macros
    base_scoped_timer
    build_info
    economy
    graphic
    graphic_playercolor
    io_fileread
    io_filesystem
    logic
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_map_objects
    logic_objectives
    logic_widelands_geometry
    logic_widelands_geometry_io
    map_io_map_loader
    notifications
    wui_mapview_pixelconstants
)

wl_library(logic_commands
  SRCS
    cmd_calculate_statistics.cc
    cmd_calculate_statistics.h
    cmd_delete_message.cc
    cmd_delete_message.h
    cmd_incorporate.cc
    cmd_incorporate.h
    cmd_luacoroutine.cc
    cmd_luacoroutine.h
    cmd_luascript.cc
    cmd_luascript.h
    cmd_queue.cc
    cmd_queue.h
    queue_cmd_factory.cc
    queue_cmd_factory.h
    queue_cmd_ids.h
    playercommand.cc
    playercommand.h
  DEPENDS
    base
    base_exceptions
    base_macros
    base_times
    economy # TODO(GunChleoc): Circular dependency
    graphic_text_layout
    io_fileread
    io_stream
    logic # TODO(GunChleoc): Circular dependency
    logic_constants
    logic_exceptions
    logic_game_controller
    logic_map
    logic_map_objects
    logic_widelands_geometry_io
    map_io
    scripting_coroutine
    scripting_logic # TODO(GunChleoc): Circular dependency
    scripting_lua_table
    wui
)


wl_library(logic_training_wheels
  SRCS
    training_wheels.cc
    training_wheels.h
  DEPENDS
    base
    io_filesystem
    io_profile
    logic_filesystem_constants
    scripting_lua_table
    scripting_lua_interface
)

wl_library(logic
  SRCS
    ai_dna_handler.cc
    ai_dna_handler.h
    detected_port_space.cc
    detected_port_space.h
    editor_game_base.cc
    editor_game_base.h
    game.cc
    game.h
    message.h
    message_id.h
    message_queue.h
    player.cc
    player.h
    player_area.h
    playersmanager.cc
    playersmanager.h
    replay.cc
    replay.h
    save_handler.cc
    save_handler.h
    trade_agreement.h
  # TODO(sirver): Uses SDL2 only on WIN32 for a dirty hack.
  USES_SDL2
  USES_ATOMIC
  DEPENDS
    base
    base_crypto
    base_exceptions
    base_macros
    base_random
    base_scoped_timer
    base_time_string
    base_times
    build_info
    economy
    game_io
    graphic
    graphic_color
    graphic_playercolor
    io_fileread
    io_filesystem
    io_profile
    io_stream
    logic_addons
    logic_commands
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_generic_save_handler
    logic_map
    logic_map_objects
    logic_tribe_basic_info
    logic_training_wheels
    logic_widelands_geometry
    map_io
    map_io_map_loader
    note_sound
    notifications
    scripting_logic # TODO(GunChleoc): Circular dependency
    scripting_lua_interface
    scripting_lua_table
    sound
    sound_constants
    ui_basic
    ui_basic_loading_message
    widelands_options
    wui # TODO(GunChleoc): Circular dependency
    wui_game_tips
)

add_subdirectory(map_objects)

=== src/map_io/CMakeLists.txt ===
wl_library(map_io_map_loader
  SRCS
    map_loader.h
    widelands_map_loader.cc
    widelands_map_loader.h
    s2map.cc
    s2map.h
  DEPENDS
    base
    base_exceptions
    base_macros
    base_scoped_timer
    io_fileread
    io_filesystem
    logic
    logic_filesystem_constants
    logic_map
    logic_map_objects
    map_io
    ui_basic
)

# TODO(sirver): separate map_object_loader/saver into
# own library.
wl_library(map_io
  SRCS
    coords_profile.cc
    coords_profile.h
    map_allowed_building_types_packet.cc
    map_allowed_building_types_packet.h
    map_allowed_worker_types_packet.cc
    map_allowed_worker_types_packet.h
    map_bob_packet.cc
    map_bob_packet.h
    map_building_packet.cc
    map_building_packet.h
    map_buildingdata_packet.cc
    map_buildingdata_packet.h
    map_data_packet.h
    map_elemental_packet.cc
    map_elemental_packet.h
    map_flag_packet.cc
    map_flag_packet.h
    map_flagdata_packet.cc
    map_flagdata_packet.h
    map_heights_packet.cc
    map_heights_packet.h
    map_images.cc
    map_images.h
    map_message_saver.h
    map_node_ownership_packet.cc
    map_node_ownership_packet.h
    map_object_loader.cc
    map_object_loader.h
    map_object_packet.cc
    map_object_packet.h
    map_object_saver.cc
    map_object_saver.h
    map_objective_packet.cc
    map_objective_packet.h
    map_packet_versions.h
    map_player_names_and_tribes_packet.cc
    map_player_names_and_tribes_packet.h
    map_player_position_packet.cc
    map_player_position_packet.h
    map_players_messages_packet.cc
    map_players_messages_packet.h
    map_players_view_packet.cc
    map_players_view_packet.h
    map_port_spaces_packet.cc
    map_port_spaces_packet.h
    map_resources_packet.cc
    map_resources_packet.h
    map_road_packet.cc
    map_road_packet.h
    map_roaddata_packet.cc
    map_roaddata_packet.h
    map_saver.cc
    map_saver.h
    map_scripting_packet.cc
    map_scripting_packet.h
    map_terrain_packet.cc
    map_terrain_packet.h
    map_version_packet.cc
    map_version_packet.h
    map_waterway_packet.cc
    map_waterway_packet.h
    map_waterwaydata_packet.cc
    map_waterwaydata_packet.h
    map_wincondition_packet.cc
    map_wincondition_packet.h
  USES_ATOMIC
  DEPENDS
    base
    base_exceptions
    base_macros
    base_scoped_timer
    economy
    graphic
    graphic_image_io
    graphic_minimap_renderer
    graphic_playercolor
    graphic_surface
    io_fileread
    io_filesystem
    io_profile
    logic
    logic_constants
    logic_exceptions
    logic_map
    logic_map_objects
    logic_objectives
    logic_widelands_geometry
    logic_widelands_geometry_io
    scripting_logic
    ui_basic
)

=== src/network/CMakeLists.txt ===
wl_library(network
  SRCS
    bufferedconnection.cc
    bufferedconnection.h
    constants.h
    internet_gaming.cc
    internet_gaming.h
    internet_gaming_messages.cc
    internet_gaming_messages.h
    internet_gaming_protocol.h
    gameclient.cc
    gameclient.h
    gamehost.cc
    gamehost.h
    host_game_settings_provider.cc
    host_game_settings_provider.h
    net_addons.cc
    net_addons.h
    netclient_interface.h
    netclient.cc
    netclient.h
    netclientproxy.cc
    netclientproxy.h
    nethost_interface.h
    nethost.cc
    nethost.h
    nethostproxy.cc
    nethostproxy.h
    network.cc
    network.h
    network_gaming_messages.cc
    network_gaming_messages.h
    network_lan_promotion.cc
    network_lan_promotion.h
    network_player_settings_backend.cc
    network_player_settings_backend.h
    network_protocol.h
    relay_protocol.h
    participantlist.cc
    participantlist.h
  USES_SDL2
  DEPENDS
    ai
    base
    base_crypto
    base_exceptions
    base_macros
    base_math
    base_random
    base_time_string
    build_info
    chat
    game_io
    graphic
    io_fileread
    io_filesystem
    io_stream
    logic
    logic_addons
    logic_commands
    logic_constants
    logic_filesystem_constants
    logic_game_controller
    logic_game_settings
    logic_tribe_basic_info
    map_io_map_loader
    notifications
    scripting_lua_interface
    scripting_lua_table
    ui_basic
    ui_fsmenu
    widelands_ball_of_mud
    widelands_options
    wui
)

=== debian/changelog ===
widelands (2:1.2.1-3) unstable; urgency=medium

  * Team upload.
  * Disable checking the local copy of the GPL versus the slightly edited
    one in base-files for the Trixie release (Closes: #1106308)

 -- Alexandre Detiste <tchet@debian.org>  Fri, 30 May 2025 12:26:03 +0200

widelands (2:1.2.1-2) unstable; urgency=medium

  * Depends on fonts-culmus-fancy instead of the transition package
    culmus-fancy (Closes: #1069584).
  * Allow to build several times in a row by ignoring in d/s/options
    the files we remove during the initial cleaning to ensure that
    embeded libraries are not used (Closes: #1047250).

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Dec 2024 16:36:44 +0100

widelands (2:1.2.1-1) unstable; urgency=medium

  * New upstream release.
    From the announcement email: This point release fixes several bugs
    and crashes found in Widelands 1.2, and offers full compatibility
    between these two releases for multiplayer games and replays.
  * d/p/RelWithDebInfo: dropped (applied upstream).

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Dec 2024 00:13:10 +0100

=== debian/control ===
Source: widelands
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
  Martin Quinson <mquinson@debian.org>,
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13),
  cmake,
  libasio-dev,
  libminizip-dev,
  libboost-dev,
  libboost-regex-dev,
  libboost-test-dev,
  libboost-system-dev,
  libcurl4-gnutls-dev,
  libglew-dev,
  libmd-dev,
  libpng-dev,
  libsdl2-dev,
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libsdl2-ttf-dev,
  python3,
  zlib1g-dev
Vcs-Git: https://salsa.debian.org/games-team/widelands.git
Vcs-Browser: https://salsa.debian.org/games-team/widelands
Homepage: http://www.widelands.org/
Rules-Requires-Root: no

Package: widelands
Architecture: any
Depends: widelands-data (= ${source:Version}),
  ${shlibs:Depends},
  ${misc:Depends},
Description: fantasy real-time strategy game
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

Package: widelands-data
Architecture: all
Depends: fonts-freefont-ttf,
  fonts-dejavu-core,
  fonts-dejavu-extra,
  fonts-hosny-amiri,
  fonts-nakula,
  fonts-wqy-microhei,
  fonts-culmus-fancy,
  ${misc:Depends}
Description: fantasy real-time strategy game (data files)
 This package contains the graphics and levels for Widelands.
 .
 Widelands is a strategy game aiming for gameplay similar to Settlers II by
 BlueByte.
 .
 In this game, you start out on a small piece of land with nothing more than
 a few of useful resources. Using those, you can build yourself an empire
 with many thousands of inhabitants. On your way towards this goal, you will
 have to build up an economic infrastructure, explore the lands around you
 and face enemies who are trying to rule the world just like you do.

=== debian/watch ===
# test this watch file using:
# uscan --watchfile debian/watch --upstream-version 0.0.1 --package widelands
#
version=4
opts="uversionmangle=s/-rc/~rc/, \
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
https://github.com/widelands/widelands/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
